import CloudKernel from 'mpserverless-sdk-core';
import * as $tea from '@alicloud/tea-typescript';
export declare class BillDetail extends $tea.Model {
    tradeNo: string;
    amount: string;
    status: string;
    partnerId: string;
    partnerName: string;
    bizType: string;
    gmtCreate: string;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class AlipayMarktingExchangevoucherUseResponse extends $tea.Model {
    code: string;
    msg: string;
    subCode: string;
    subMsg: string;
    voucherId: string;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class AlipayMarketingVoucherSendResponse extends $tea.Model {
    code: string;
    msg: string;
    subCode: string;
    subMsg: string;
    voucherId: string;
    userId: string;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class AlipayMarketingExchangevouherTemplateCreateResponse extends $tea.Model {
    code: string;
    msg: string;
    subCode: string;
    subMsg: string;
    templateId: string;
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export declare class AlipayMarketingVoucherQueryResponse extends $tea.Model {
    code: string;
    msg: string;
    subCode: string;
    subMsg: string;
    name: string;
    voucherId: string;
    userId: string;
    templateId: string;
    gmtActive: string;
    gmtExpired: string;
    totalAmount: string;
    availableAmount: string;
    status: string;
    gmtCreate: string;
    extendInfo: string;
    billDetails: BillDetail[];
    static names(): {
        [key: string]: string;
    };
    static types(): {
        [key: string]: any;
    };
    constructor(map?: {
        [key: string]: any;
    });
}
export default class Client {
    _kernel: CloudKernel;
    constructor(_kernel: CloudKernel);
    create(outBizNo: string, brandName: string, voucherName: string, quantity: number, publishStartTime: string, publishEndTime: string, validPeriod: string, availableTime: string, description: string, extensionInfo: string): Promise<AlipayMarketingExchangevouherTemplateCreateResponse>;
    send(templateId: string, userId: string, outBizNo: string): Promise<AlipayMarketingVoucherSendResponse>;
    use(voucherId: string, userId: string, outBizNo: string): Promise<AlipayMarktingExchangevoucherUseResponse>;
    query(voucherId: string): Promise<AlipayMarketingVoucherQueryResponse>;
}
