"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var is_string_1 = __importDefault(require("./is-string"));
var is_object_1 = __importDefault(require("./is-object"));
var is_number_1 = __importDefault(require("./is-number"));
/**
 * set object value by path
 * @example
 * set({ a: 1, b: { c: 2 }}, 'b.c', 3);
 * @param {object} obj
 * @param {string | array} path
 * @param {any} value
 * @returns
 */
function set(obj, path, value) {
    var _obj = obj;
    var keyArr = is_string_1.default(path) ? path.split('.') : path;
    keyArr.forEach(function (key, idx) {
        if (idx < (keyArr.length - 1)) {
            if (!is_object_1.default(_obj[key])) {
                _obj[key] = is_number_1.default(keyArr[idx + 1]) ? [] : {};
            }
            _obj = _obj[key];
        }
        else {
            _obj[key] = value;
        }
    });
    return obj;
}
exports.default = set;
//# sourceMappingURL=set.js.map